/*
 ķ
   Program..: KEYPAD2.PRG                           
   Author...: Roger Donnay                          
   Date.....: Oct 5, 2005                           
 Ľ
*/

#include 'inkey.ch'
#include 'dccolor.ch'
#include 'appevent.ch'
#include 'gra.ch'
#include 'xbp.ch'
#include 'dcmsg.ch'
#include 'dcdialog.ch'

MEMVAR lCapsLock, cCapsLock

FUNCTION PopKeyPad( cValue, cLocation, cTitle, lCapsLockOn, lPassword )

LOCAL GetList := {}, GetOptions, cSaveValue, oCancelButton, lReturn := .t., ;
   nWidth := AppDeskTop():currentSize()[1], aScale, cFont, cFixedFont

PRIVATE lFirstTime := .t., lCapsLock, cCapsLock, lPasswordMode, cAccum := ''

DEFAULT lCapsLockOn := .f., ;
        cValue := space(30), ;
        lPassword := .F.

aScale := DC_GetOptDefault()[aGETOPT_SCALEFACTOR]

cFont := Alltrim(Str(Round(7 * aScale[4],0))) + '.Arial Bold'
cFixedFont := Alltrim(Str(Round(9 * aScale[4],0))) + '.Courier New Bold'

lPasswordMode := lPassword
lCapslock := .F.
cCapsLock := '         '
IF lCapsLockOn
   lCapsLock   := .t.
   cCapsLock   := "Caps Lock"
ENDIF

DEFAULT cLocation   := ""
DEFAULT cTitle      := "Virtual Keyboard"

cSaveValue := cValue

@ 20,  0 DCGET cValue FONT cFixedFont SIZE 680,60 PIXEL ;
   EDITPROTECT {||.t.} ID 'ACCUM'

@ 100,  0 DCPUSHBUTTON CAPTION {||IIF( lCapsLock,'!','1') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('1','!',@cValue,GetList)} ;
   ACCELKEY Asc('1') ;

   @ 100, 50 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'@','2') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('2','@',@cValue,GetList)} ;
   ACCELKEY Asc('2') ;

   @ 100,100 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'#','3') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('3','#',@cValue,GetList)} ;
   ACCELKEY Asc('3') ;

   @ 100,150 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'$','4') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('4','$',@cValue,GetList)} ;
   ACCELKEY Asc('4') ;

   @ 100,200 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'%','5') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('5','%',@cValue,GetList)} ;
   ACCELKEY Asc('5') ;

   @ 100,250 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'^','6') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('6','^',@cValue,GetList)} ;
   ACCELKEY Asc('6') ;

   @ 100,300 DCPUSHBUTTON CAPTION {||iif( lCapsLock,' &&','7') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('7','&',@cValue,GetList)} ;
   ACCELKEY Asc('7') ;

   @ 100,350 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'*','8') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('8','*',@cValue,GetList)} ;
   ACCELKEY Asc('8') ;

   @ 100,400 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'(','9') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('9','(',@cValue,GetList)} ;
   ACCELKEY Asc('9') ;

   @ 100,450 DCPUSHBUTTON CAPTION {||iif( lCapsLock,')','0') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('0',')',@cValue,GetList)} ;
   ACCELKEY Asc('0') ;

   @ 100,500 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'_','-') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('-','_',@cValue,GetList)} ;
   ACCELKEY {Asc('-'),Asc('_')} ;

   @ 100,550 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'+','=') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('=','+',@cValue,GetList)} ;
   ACCELKEY {Asc('='),Asc('+')} ;

   @ 100,600 DCPUSHBUTTON CAPTION 'BS' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||cAccum := Substr(cAccum,1,Len(cAccum)-1),Accum('','',@cValue,GetList)} ;
   ACCELKEY 8 ;

   @ 150, 20 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'Q','q') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('q','Q',@cValue,GetList)} ;
   ACCELKEY {Asc('q'),Asc('Q')} ;

   @ 150, 70 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'W','w') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('w','W',@cValue,GetList)} ;
   ACCELKEY {Asc('w'),Asc('W')} ;

   @ 150,120 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'E','e') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('e','E',@cValue,GetList)} ;
   ACCELKEY {Asc('e'),Asc('E')} ;

   @ 150,170 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'R','r') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('r','R',@cValue,GetList)} ;
   ACCELKEY {Asc('r'),Asc('R')} ;

   @ 150,220 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'T','t') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('t','T',@cValue,GetList)} ;
   ACCELKEY {Asc('t'),Asc('T')} ;

   @ 150,270 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'Y','y') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('y','Y',@cValue,GetList)} ;
   ACCELKEY {Asc('y'),Asc('Y')} ;

   @ 150,320 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'U','u') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('u','U',@cValue,GetList)} ;
   ACCELKEY {Asc('u'),Asc('U')} ;

   @ 150,370 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'I','i') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('i','I',@cValue,GetList)} ;
   ACCELKEY {Asc('i'),Asc('I')} ;

   @ 150,420 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'O','o') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('o','O',@cValue,GetList)} ;
   ACCELKEY {Asc('o'),Asc('O')} ;

   @ 150,470 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'P','p') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('p','P',@cValue,GetList)} ;
   ACCELKEY {Asc('p'),Asc('P')} ;

   @ 150,520 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'{','[') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('[','{',@cValue,GetList)} ;
   ACCELKEY {Asc('['),Asc('{')} ;

   @ 150,570 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'}',']') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(']','}',@cValue,GetList)} ;
   ACCELKEY {Asc(']'),Asc('}')} ;

   @ 150,620 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'|','\') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('\','|',@cValue,GetList)} ;
   ACCELKEY {Asc('\'),Asc('|')} ;

   @ 200, 40 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'A','a') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('a','A',@cValue,GetList)} ;
   ACCELKEY {Asc('a'),Asc('A')} ;

   @ 200, 90 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'S','s') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('s','S',@cValue,GetList)} ;
   ACCELKEY {Asc('s'),Asc('S')} ;

   @ 200,140 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'D','d') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('d','D',@cValue,GetList)} ;
   ACCELKEY {Asc('d'),Asc('D')} ;

   @ 200,190 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'F','f') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('f','F',@cValue,GetList)} ;
   ACCELKEY {Asc('f'),Asc('F')} ;

   @ 200,240 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'G','g') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('g','G',@cValue,GetList)} ;
   ACCELKEY {Asc('g'),Asc('G')} ;

   @ 200,290 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'H','h') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('h','H',@cValue,GetList)} ;
   ACCELKEY {Asc('h'),Asc('H')} ;

   @ 200,340 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'J','j') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('j','J',@cValue,GetList)} ;
   ACCELKEY {Asc('j'),Asc('J')} ;

   @ 200,390 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'K','k') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('k','K',@cValue,GetList)} ;
   ACCELKEY {Asc('k'),Asc('K')} ;

   @ 200,440 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'L','l') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('l','L',@cValue,GetList)} ;
   ACCELKEY {Asc('l'),Asc('L')} ;

   @ 200,490 DCPUSHBUTTON CAPTION {||iif( lCapsLock,':',';') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(';',':',@cValue,GetList)} ;
   ACCELKEY {Asc(';'),Asc(':')} ;

   @ 200,540 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'"',"'") } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum("'",'"',@cValue,GetList)} ;
   ACCELKEY {Asc("'"),Asc('"')} ;

   @ 250, 60 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'Z','z') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('z','Z',@cValue,GetList)} ;
   ACCELKEY {Asc('z'),Asc('Z')} ;

   @ 250,110 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'X','x') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('x','X',@cValue,GetList)} ;
   ACCELKEY {Asc('x'),Asc('X')} ;

   @ 250,160 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'C','c') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('c','C',@cValue,GetList)} ;
   ACCELKEY {Asc('c'),Asc('C')} ;

@ 250,210 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'V','v') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('v','V',@cValue,GetList)} ;
   ACCELKEY {Asc('v'),Asc('V')} ;

   @ 250,260 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'B','b') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('b','B',@cValue,GetList)} ;
   ACCELKEY {Asc('b'),Asc('B')} ;

   @ 250,310 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'N','n') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('n','N',@cValue,GetList)} ;
   ACCELKEY {Asc('n'),Asc('N')} ;

   @ 250,360 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'M','m') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('m','M',@cValue,GetList)} ;
   ACCELKEY {Asc('m'),Asc('M')} ;

   @ 250,410 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'<',',') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(',','<',@cValue,GetList)} ;
   ACCELKEY {Asc(','),Asc('<')} ;

   @ 250,460 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'>','.') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('.','>',@cValue,GetList)} ;
   ACCELKEY {Asc('.'),Asc('>')} ;

   @ 250,510 DCPUSHBUTTON CAPTION {||iif( lCapsLock,'?','/') } FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum('/','?',@cValue,GetList)} ;
   ACCELKEY {Asc('/'),Asc('?')} ;

   @ 300, 0 DCPUSHBUTTON CAPTION 'Caps' FONT cFont SIZE 100,50 PIXEL ;
   ACTION {|a,b,o|lCapsLock:=!lCapsLock, ;
   cCapsLock := IIF(lCapsLock, "Caps Lock", ""), ;
   DC_GetRefresh(GetList)}

@ 300,100 DCPUSHBUTTON CAPTION ' ' FONT cFont SIZE 400,50 PIXEL ;
   ACTION {||Accum(' ',' ',@cValue,GetList)} ;
   ACCELKEY 32

@ 300,500 DCPUSHBUTTON CAPTION 'Caps' FONT cFont SIZE 100,50 PIXEL ;
   ACTION {|a,b,o|lCapsLock:=!lCapsLock, ;
   cCapsLock := IIF(lCapsLock, "Caps Lock", ""), ;
   DC_GetRefresh(GetList)}

@ 200,590 DCPUSHBUTTON CAPTION 'Enter' FONT cFont SIZE 90,50 PIXEL ;
   ACCELKEY 13 ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ 300,600 DCPUSHBUTTON CAPTION 'Esc' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   ACCELKEY 27 ;
   OBJECT oCancelButton

aCoords     := DC_GetWorkArea()
nDheight    := aCoords[4] - aCoords[2]          //right - left
nDwidth     := aCoords[3] - aCoords[1]          //bottom - top

DCGETOPTIONS ;
   COLOR GRA_CLR_DARKBLUE ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   HIDE ;
   SCALEFACTOR { .34*aScale[1], .34*aScale[2], .34*aScale[3], .34*aScale[4], .f. }

DCREAD GUI FIT MODAL ;
   TITLE cTitle ;
   SETFOCUS @oCancelButton ;
   TO lStatus ;
   OPTIONS GetOptions ;
   EVAL {|o|DC_CenterObject(o, SetAppWindow()), ;
            o:show()}

IF !lStatus
   cValue := cSaveValue
ENDIF
cValue := cAccum

RETURN cValue

* ------------

STATIC FUNCTION Accum ( cKey, cCapsKey, cValue, GetList )

LOCAL oGet

IF lFirstTime
  cValue := ''
  cAccum := ''
ENDIF

lFirstTime := .f.

cAccum += iif(lCapsLock,cCapsKey,cKey)

IF lPasswordMode
  cValue := Repl('*',Len(cAccum))
ELSE
  cValue := cAccum
ENDIF

DC_GetRefresh(GetList,'ACCUM')

RETURN nil


