/*
 ķ
   Program..: NUMPAD2.PRG                           
   Author...: Roger J. Donnay                       
   Date.....: Oct. 4, 2005                          
 Ľ
*/

#include 'inkey.ch'
#include 'dccolor.ch'
#include 'appevent.ch'
#include 'gra.ch'
#include 'xbp.ch'
#include 'dcmsg.ch'
#include 'dcdialog.ch'


FUNCTION PopNumPad( nValue, cLocation, cTitle )

LOCAL GetList := {}, GetOptions, nSaveValue, oCancelButton, lReturn := .t., ;
      aScale, cFont, cFixedFont

PRIVATE lFirstTime := .t.


DEFAULT nValue := 0, cLocation := "", cTitle := ""
PRIVATE nAccum := nValue

aScale := DC_GetOptDefault()[aGETOPT_SCALEFACTOR]

cFont := Alltrim(Str(Round(7 * aScale[4],0))) + '.Arial Bold'
cFixedFont := Alltrim(Str(Round(9 * aScale[4],0))) + '.Courier New Bold'

nSaveValue := nValue

cValue := Alltrim(Str(nValue))
cValue := PadL(cValue,16)

@  -10,   0 DCGET cValue FONT cFixedFont ;
   PIXEL ;
   EDITPROTECT {||.t.} ID 'ACCUM'

@  50,  0 DCPUSHBUTTON CAPTION '7' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(7,@cValue,GetList)} ;
   ACCELKEY Asc('7')

@  50, 60 DCPUSHBUTTON CAPTION '8' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(8,@cValue,GetList)} ;
   ACCELKEY Asc('8')

@  50,120 DCPUSHBUTTON CAPTION '9' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(9,@cValue,GetList)} ;
   ACCELKEY Asc('9')

@ 110,  0 DCPUSHBUTTON CAPTION '4' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(4,@cValue,GetList)} ;
   ACCELKEY Asc('4')

@ 110, 60 DCPUSHBUTTON CAPTION '5' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(5,@cValue,GetList)} ;
   ACCELKEY Asc('5')

@ 110,120 DCPUSHBUTTON CAPTION '6' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(6,@cValue,GetList)} ;
   ACCELKEY Asc('6')

@ 170,  0 DCPUSHBUTTON CAPTION '1' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(1,@cValue,GetList)} ;
   ACCELKEY Asc('1')

@ 170, 60 DCPUSHBUTTON CAPTION '2' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(2,@cValue,GetList)} ;
   ACCELKEY Asc('2')

@ 170,120 DCPUSHBUTTON CAPTION '3' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(3,@cValue,GetList)} ;
   ACCELKEY Asc('3')

@ 230,  0 DCPUSHBUTTON CAPTION '0' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(0,@cValue,GetList)} ;
   ACCELKEY Asc('0')

@ 230, 60 DCPUSHBUTTON CAPTION '.' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(10,@cValue,GetList)} ;
   ACCELKEY 46

@ 230,120 DCPUSHBUTTON CAPTION '-' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(11,@cValue,GetList)} ;
   ACCELKEY 45

@ 290,  0 DCPUSHBUTTON CAPTION 'CL' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||Accum(12,@cValue,GetList)} ;
   ACCELKEY { 67, 99 }

@ 290, 90 DCPUSHBUTTON CAPTION 'BS' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||Accum(13,@cValue,GetList)} ;
   ACCELKEY 8

@ 110,190 DCPUSHBUTTON CAPTION 'CR' FONT cFont SIZE 80,50 PIXEL ;
   ACCELKEY 13 ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ 170,190 DCPUSHBUTTON CAPTION 'Esc' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||lReturn := .f., DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   ACCELKEY 27 ;
   OBJECT oCancelButton

    aCoords     := DC_GetWorkArea()
    nDheight    := aCoords[4] - aCoords[2]  //right - left
    nDwidth     := aCoords[3] - aCoords[1]  //bottom - top

    IF EMPTY(cTitle)
        DCGETOPTIONS ;
            NOTITLE ;
            HIDE ;
            SCALEFACTOR { .4*aScale[1], .4*aScale[2], .4*aScale[3], .4*aScale[4], .f. }
    ELSE
        DCGETOPTIONS ;
            NOMINBUTTON ;
            NOMAXBUTTON ;
            HIDE ;
         SCALEFACTOR { .4*aScale[1], .4*aScale[2], .4*aScale[3], .4*aScale[4], .f. }
   ENDIF

    DCREAD GUI FIT MODAL ;
            TITLE cTitle ;
            SETFOCUS @oCancelButton ;
            TO lStatus ;
            OPTIONS GetOptions ;
            EVAL {|o|DC_CenterObject(o,SetAppWindow()), ;
                     o:show()}

IF !lStatus
  nValue := nSaveValue
ELSE
  nValue := Val(cValue)
ENDIF

RETURN nValue

* --------------

FUNCTION PopNumPad_P( nValue, cLocation, cTitle )

LOCAL GetList := {}, GetOptions, nSaveValue, oCancelButton, lReturn := .t., ;
      lString, aScale, cFont, cFixedFont

PRIVATE lFirstTime := .t.

cLocation := ""
DEFAULT cTitle := ""

nSaveValue := nValue

lString := .f.

aScale := DC_GetOptDefault()[aGETOPT_SCALEFACTOR]

cFont := Alltrim(Str(Round(7 * aScale[4],0))) + '.Arial Bold'
cFixedFont := Alltrim(Str(Round(9 * aScale[4],0))) + '.Courier New Bold'

IF Valtype(nValue) = 'C'
  cValue  := PadL(Alltrim(nValue),16)
  lString := .t.

ELSE
  cValue  := PadL(Alltrim(Str(nValue)),16)
ENDIF

@  -90, 0 DCSAY cTitle FONT cFont SAYSIZE 280,80 PIXEL ;
          SAYWORDBREAK

@  0, 0 DCGET cValue FONT cFixedFont ;
   ;// SIZE 250,40 ;
   PIXEL ;
   EDITPROTECT {||.t.} ID 'ACCUM'

@  50,  0 DCPUSHBUTTON CAPTION '7' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(7,@cValue,GetList)} ;
   ACCELKEY Asc('7') ;

@  50, 60 DCPUSHBUTTON CAPTION '8' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(8,@cValue,GetList)} ;
   ACCELKEY Asc('8') ;

@  50,120 DCPUSHBUTTON CAPTION '9' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(9,@cValue,GetList)} ;
   ACCELKEY Asc('9') ;

@ 110,  0 DCPUSHBUTTON CAPTION '4' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(4,@cValue,GetList)} ;
   ACCELKEY Asc('4') ;

@ 110, 60 DCPUSHBUTTON CAPTION '5' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(5,@cValue,GetList)} ;
   ACCELKEY Asc('5') ;

@ 110,120 DCPUSHBUTTON CAPTION '6' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(6,@cValue,GetList)} ;
   ACCELKEY Asc('6') ;

@ 170,  0 DCPUSHBUTTON CAPTION '1' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(1,@cValue,GetList)} ;
   ACCELKEY Asc('1') ;

@ 170, 60 DCPUSHBUTTON CAPTION '2' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(2,@cValue,GetList)} ;
   ACCELKEY Asc('2') ;

@ 170,120 DCPUSHBUTTON CAPTION '3' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(3,@cValue,GetList)} ;
   ACCELKEY Asc('3') ;

@ 230,  0 DCPUSHBUTTON CAPTION '0' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(0,@cValue,GetList)} ;
   ACCELKEY Asc('0') ;

@ 230, 60 DCPUSHBUTTON CAPTION '.' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(10,@cValue,GetList)} ;
   ACCELKEY 46 ;

@ 230,120 DCPUSHBUTTON CAPTION '-' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(11,@cValue,GetList)} ;
   ACCELKEY 45 ;

@ 290,  0 DCPUSHBUTTON CAPTION 'CL' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||Accum(12,@cValue,GetList)} ;
   ACCELKEY { 67, 99 } ;

@ 290, 90 DCPUSHBUTTON CAPTION 'BS' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||Accum(13,@cValue,GetList)} ;
   ACCELKEY 8 ;

@ 110,190 DCPUSHBUTTON CAPTION 'Enter' FONT cFont SIZE 80,50 PIXEL ;
   ACCELKEY 13 ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ 170,190 DCPUSHBUTTON CAPTION 'Esc' FONT cFont SIZE 80,50 PIXEL ;
   ACTION {||lReturn := .f., DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   ACCELKEY 27 ;
   OBJECT oCancelButton

@ 230,190 DCPUSHBUTTON CAPTION '%' FONT cFont SIZE 50,50 PIXEL ;
   ACTION {||Accum(20,@cValue,GetList)} ;
   ACCELKEY Asc('%') ;
   WHEN {|| lString } ;

    aCoords     := DC_GetWorkArea()
    nDheight    := aCoords[4] - aCoords[2]  //right - left
    nDwidth     := aCoords[3] - aCoords[1]  //bottom - top

    IF EMPTY(cTitle)
        DCGETOPTIONS ;
            NOTITLE ;
            HIDE ;
            SCALEFACTOR { .5*aScale[1], .5*aScale[2], .5*aScale[3], .5*aScale[4], .f. }
    ELSE
        DCGETOPTIONS ;
            NOMINBUTTON ;
            NOMAXBUTTON ;
            HIDE ;
         SCALEFACTOR { .5*aScale[1], .5*aScale[2], .5*aScale[3], .5*aScale[4], .f. }
    ENDIF

    DCREAD GUI FIT MODAL ;
            TITLE 'Numeric Pad     ' ;
            SETFOCUS @oCancelButton ;
            TO lStatus ;
            OPTIONS GetOptions ;
            EVAL {|o|DC_CenterObject(o,SetAppWindow()), ;
                     o:show()}

IF !lStatus
  nValue := nSaveValue
ELSE
  IF lString
    nValue := Alltrim(cValue)
  ELSE
    nValue := Val(cValue)
  ENDIF
ENDIF

RETURN nValue

* ----------------

STATIC FUNCTION Accum ( nKey, cValue, GetList )

IF lFirstTime .AND. nKey # 20
  cValue := ''
ELSE
  cValue := Alltrim(cValue)
ENDIF

lFirstTime := .f.

IF nKey >= 0 .AND. nKey <= 9

  cValue += Alltrim(Str(nKey))

ELSEIF nKey == 10 // Decimal key

  cValue := StrTran(cValue,'.','')
  cValue += '.'

ELSEIF nKey == 11 // Minus Key

  IF Left(cValue,1) == '-'
    cValue := Substr(cValue,2)
  ELSE
    cValue := '-' + cValue
  ENDIF

ELSEIF nKey == 12 // Clear

  cValue := ''

ELSEIF nKey == 13 // Backspace

  cValue := Substr(cValue,1,Len(cValue)-1)

ELSEIF nKey == 20 .AND. !('%'$cValue) // Percent

  cValue += '%'

ENDIF

cValue := Trim(cValue)

IF '%' $ cValue
  cValue := Strtran(cValue,'%','') + '%'
ENDIF

cValue := PadL(cValue,16)

DC_GetRefresh(GetList,'ACCUM')

RETURN nil



